<?php

define('SKIP_KOHANA', true);
require_once('/opt/monitor/op5/ninja/index.php');

require_once('op5/auth/Auth.php');
require_once(__DIR__ . '/NinjaConfig.php');

/**
 * Created by JetBrains PhpStorm.
 * User: Valeriy Stukanov
 * Date: 9/6/11
 * Time: 2:29 PM
 */
class ExtAuthModNinja extends CoreAuthModule
{
	protected $op5auth = null;

	public function __construct()
	{
		if ((isset($_GET, $_GET['request_context'], $_GET["widget"]) && $_GET['request_context'] === 'external_widget')) {

			$external_config = NinjaConfig::load('external_widget');
			$widget_name = $_GET['widget'];

			$groups = array();
			$username = "";

			if (isset($external_config["widgets"], $external_config["widgets"][$widget_name])
				&& isset($external_config["username"], $external_config["groups"])) {

				$widget = $external_config["widgets"][$widget_name];
				$username = $external_config["username"];
				$groups = $external_config["groups"];

			} else {

			}

			$this->op5auth = op5auth::instance(array(
				'enable_auto_login' => true
			));

			parent::$aFeatures = array(
				'getCredentials' => true,
				'isAuthenticated' => true,
				'getUser' => true
			);

			$this->op5auth->get_user();
			$this->op5auth->write_close();
			$user = new User_Model(array(
				'username' => $username,
				'groups' => $groups
			));

			$this->op5auth->force_user($user);

		} else {

			parent::$aFeatures = array(
				'getCredentials' => true,
				'isAuthenticated' => true,
				'getUser' => true
			);

			$conf = $driver = array();
			if (isset($_SESSION['external_widget_username'])) {
				$conf = array(
					'enable_auto_login' => true,
					'default_auth' => 'Session',
					'session_key' => false,
				);

				$driver = array(
					'Session' => array(
						'driver' => 'Session',
						'username_session_key' => 'external_widget_username',
						'groups_session_key' => 'external_widget_groups'
					)
				);
			}

			$this->op5auth = Op5Auth::factory($conf, $driver);
		}
	}

	public function passCredentials($aData)
	{
	}

	public function passNewPassword($aData)
	{
	}

	public function changePassword()
	{
	}

	public function getCredentials()
	{
		$user = $this->op5auth->get_user();
		return array(
			'user'      => $user->get_username(),
		);
	}

	public function isAuthenticated()
	{
		return $this->op5auth->logged_in();
	}

	public function getUser()
	{
		return $this->op5auth->get_user()->get_username();
	}

	public function getUserId()
	{
		return $this->getUser();
	}

	public function getOp5Auth() {
		return $this->op5auth;
	}

	//public function createPermission() {}
}
